CoCoA-5 - Design #1407

Tagged values (Hilbert Series)
30 Jan 2020 14:14 - John Abbott

Status: Closed Start date: 30 Jan 2020
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 100%
Category: bug Estimated time: 1.51 hour
Target version: CoCoA-5.4.0 Spent time: 1.20 hour
Description

Bernhard Andraschko has a new program which calculates Hilbert series.

He would like to make it produce a result compatible with the result produced by the fns in hp.cpkg5.

The problem is that tagging takes into account the "active" package at the time that the tag was applied.

So he gets an object of "type" TopLevel. HPSeries instead of hp.HPSeries; and the fns in hp.cpkg5 refuse to handle his Hilbert series
(e.g for printing).

How to resolve this? Neatly!

History

#1 - 31 Jan 2020 10:46 - Anna Maria Bigatti
- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 20

Fate wants that I'm facing exactly the same problem!!

And | have a neat idea in mind!
Bernhard: which tags do you need? just HPSeries?

#2 - 31 Jan 2020 11:25 - Bernhard Andraschko

Yes, i just want to create a "new" Hilbert series without knowing a generating system of the ring corresponding to it.
For getting the values of the Hilbert function | have to do EvalHilbertFn(HS,d) which involves a type check.

#3 - 31 Jan 2020 13:57 - Anna Maria Bigatti

Done.
The solution | implemented is this. (a bit like public/private functions in C++)
The package $hp, responsible of the tags, exports the functions

TaggedHilbertFn (X) ;
TaggedHilbertSeries (X) ;

which return X with the desired tag.

I modify hp.cpkg5 so that it uses these functions internally as well.

From other packages this is the only way to assign the tags (Giovanni Lagorio actually made a good design, preventing tags outside the defining
package!!).

When | have time, I'll also add some sanity check on X, for example that it must be a record with suitable fields. This way the "tag" will also be a

certification of well formed object.

| think this is neat!
#4 - 31 Jan 2020 13:58 - Anna Maria Bigatti
- File hp.cpkg5 added

#5 - 31 Jan 2020 14:00 - Anna Maria Bigatti
- File hp.cpkg5 added

#6 - 31 Jan 2020 14:00 - Anna Maria Bigatti
- File deleted (hp.cpkgb)

#7 - 05 Nov 2021 16:08 - John Abbott

- Status changed from New to In Progress

What is the status of this issue? It is resolved?
Is %done correct?

#8 - 03 Feb 2022 19:44 - John Abbott
- Status changed from In Progress to Feedback

- % Done changed from 20 to 90

The comments suggest that this issue is essentially fixed.. so | have advanced the status to feedback.

#9 - 18 Feb 2022 16:22 - Anna Maria Bigatti

- Subject changed from Tagged values to Tagged values (Hilbert Series)
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 1.51 h

Still to do: sanity checks (make another issue, in case...)

Files

hp.cpkg5 16.1 KB
